/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "MonochromeLib.h"
#include <stdlib.h>
#include "syscall.h"

#define numBlobs 10
#define width 128
#define height 64
//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{

	int blogPx[numBlobs];
	int blogPy[numBlobs];
	// Movement vector for each blob
	int blogDx[numBlobs];
	int blogDy[numBlobs];
	int vx[numBlobs][width];
	int vy[numBlobs][height];
	int i,j,k;
	int m;

	srand(RTC_GetTicks());

	for(i=0; i<numBlobs; i++)
	{
		blogPx[i] = rand()%width;
		blogPy[i] = rand()%height;
		if(rand()%2)
			blogDx[i] = 1;
		else
			blogDx[i] = -1;
			
		if(rand()%2)
			blogDy[i] = 1;
		else
			blogDy[i] = -1;
	}
	
	while(IsKeyUp(KEY_CTRL_EXIT))
	{
		ML_clear_vram();
		for(i=0;i<numBlobs;i++)
		{
		    blogPx[i]+=blogDx[i];
			blogPy[i]+=blogDy[i];

			// bounce across screen
			if (blogPx[i] < 0 || blogPx[i] > width -1)
				blogDx[i] *= -1;
			if (blogPy[i] < 0 || blogPy[i] > height -1)
				blogDy[i] *= -1;
			for ( j = 0; j < width; j++) {
			  vx[i][j] = (blogPx[i]-j)*(blogPx[i]-j);
			}

			for ( j = 0; j < height; j++) {
			  vy[i][j] = (blogPy[i]-j)*(blogPy[i]-j);
			}
		}
		
	  for ( j = 0; j < height; j++) {
		for ( i = 0; i < width; i++) {
		  m = 1;
		  for ( k = 0; k < numBlobs; k++) {
			// Increase this number to make your blobs bigger
			m += 3000/(vy[k][j] + vx[k][i]+1);
		  }
		 if(m > 50)
			ML_pixel(i,j,BLACK);
		}
	  }
	  for(i=0;i<numBlobs;i++)
		ML_pixel(blogPx[i],blogPy[i],WHITE);
		
		ML_display_vram();
	}

	return 1;
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

